package ex.hole;

import blang.core.BlangExtensions;
import blang.core.DeboxedName;
import blang.core.IntVar;
import blang.core.Model;
import blang.core.ModelBuilder;
import blang.core.ModelComponent;
import blang.core.RealVar;
import blang.inits.Arg;
import blang.inits.DesignatedConstructor;
import blang.types.StaticUtils;
import blang.types.internals.IntScalar;
import blang.types.internals.RealScalar;
import ca.ubc.stat.blang.StaticJavaUtils;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Optional;
import java.util.function.Supplier;
import org.eclipse.xtext.xbase.lib.IntegerRange;

@SuppressWarnings("all")
public class Both implements Model {
  public static class Builder implements ModelBuilder {
    private boolean fromCommandLine = false;
    
    @Arg
    public Optional<IntVar> indic;
    
    public Both.Builder setIndic(final IntVar indic) {
      // work around typeRef(..) limitation
      Optional<IntVar> $generated__dummy = null;
      this.indic = Optional.of(indic);
      return this;
    }
    
    @Arg
    public Optional<RealVar> alpha;
    
    public Both.Builder setAlpha(final RealVar alpha) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.alpha = Optional.of(alpha);
      return this;
    }
    
    @Arg
    public Optional<List<RealVar>> betas;
    
    public Both.Builder setBetas(final List<RealVar> betas) {
      // work around typeRef(..) limitation
      Optional<List<RealVar>> $generated__dummy = null;
      this.betas = Optional.of(betas);
      return this;
    }
    
    @Arg
    public Optional<List<IntVar>> xs;
    
    public Both.Builder setXs(final List<IntVar> xs) {
      // work around typeRef(..) limitation
      Optional<List<IntVar>> $generated__dummy = null;
      this.xs = Optional.of(xs);
      return this;
    }
    
    public Both build() {
      // For each optional type, either get the value, or evaluate the ?: expression
      IntVar indic;
      if (this.indic != null && this.indic.isPresent()) {
        indic = this.indic.get();
      } else {
        indic = $generated__11();
      }
      final IntVar __indic = indic;
      RealVar alpha;
      if (this.alpha != null && this.alpha.isPresent()) {
        alpha = this.alpha.get();
      } else {
        alpha = $generated__12(indic);
      }
      final RealVar __alpha = alpha;
      List<RealVar> betas;
      if (this.betas != null && this.betas.isPresent()) {
        betas = this.betas.get();
      } else {
        betas = $generated__13(indic, alpha);
      }
      final List<RealVar> __betas = betas;
      List<IntVar> xs;
      if (this.xs != null && this.xs.isPresent()) {
        xs = this.xs.get();
      } else {
        xs = $generated__14(indic, alpha, betas);
      }
      final List<IntVar> __xs = xs;
      // Build the instance after boxing params
      return new Both(
        __indic, 
        __alpha, 
        __betas, 
        __xs
      );
    }
  }
  
  @DesignatedConstructor
  public static Both.Builder builderFromCommandLine() {
    Builder result = new Builder();
    result.fromCommandLine = true;
    return result;
  }
  
  private final IntVar indic;
  
  public IntVar getIndic() {
    return indic;
  }
  
  private final RealVar alpha;
  
  public RealVar getAlpha() {
    return alpha;
  }
  
  private final List<RealVar> betas;
  
  public List<RealVar> getBetas() {
    return betas;
  }
  
  private final List<IntVar> xs;
  
  public List<IntVar> getXs() {
    return xs;
  }
  
  /**
   * Utility main method for posterior inference on this model
   */
  public static void main(final String[] arguments) {
    StaticJavaUtils.callRunner(Builder.class, arguments);
  }
  
  /**
   * Auxiliary method generated to translate:
   * indic
   */
  private static IntVar $generated__0(final IntVar indic, final RealVar alpha, final List<RealVar> betas, final List<IntVar> xs) {
    return indic;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0.5
   */
  private static RealVar $generated__1() {
    return new blang.core.RealConstant(0.5);
  }
  
  public static class $generated__1_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__1();
    }
    
    public String toString() {
      return "0.5";
    }
    
    public $generated__1_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * alpha
   */
  private static RealVar $generated__2(final IntVar indic, final RealVar alpha, final List<RealVar> betas, final List<IntVar> xs) {
    return alpha;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0.1
   */
  private static RealVar $generated__3() {
    return new blang.core.RealConstant(0.1);
  }
  
  public static class $generated__3_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__3();
    }
    
    public String toString() {
      return "0.1";
    }
    
    public $generated__3_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0..1
   */
  private static Iterable<Integer> $generated__4(final IntVar indic, final RealVar alpha, final List<RealVar> betas, final List<IntVar> xs) {
    IntegerRange _upTo = new IntegerRange(0, 1);
    return _upTo;
  }
  
  /**
   * Auxiliary method generated to translate:
   * betas.get(i)
   */
  private static RealVar $generated__5(final int i, final IntVar indic, final RealVar alpha, final List<RealVar> betas, final List<IntVar> xs) {
    RealVar _get = betas.get(i);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0.1
   */
  private static RealVar $generated__6() {
    return new blang.core.RealConstant(0.1);
  }
  
  public static class $generated__6_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__6();
    }
    
    public String toString() {
      return "0.1";
    }
    
    public $generated__6_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0..1
   */
  private static Iterable<Integer> $generated__7(final IntVar indic, final RealVar alpha, final List<RealVar> betas, final List<IntVar> xs) {
    IntegerRange _upTo = new IntegerRange(0, 1);
    return _upTo;
  }
  
  /**
   * Auxiliary method generated to translate:
   * betas.get(i)
   */
  private static RealVar $generated__8(final int i, final IntVar indic, final RealVar alpha, final List<RealVar> betas, final List<IntVar> xs) {
    RealVar _get = betas.get(i);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * xs.get(i)
   */
  private static IntVar $generated__9(final int i, final IntVar indic, final RealVar alpha, final List<RealVar> betas, final List<IntVar> xs) {
    IntVar _get = xs.get(i);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * if (indic == 0) alpha else beta
   */
  private static RealVar $generated__10(final RealVar beta, final RealVar alpha, final IntVar indic) {
    RealVar _xifexpression = null;
    boolean _equals = BlangExtensions.operator_equals(indic, Integer.valueOf(0));
    if (_equals) {
      _xifexpression = alpha;
    } else {
      _xifexpression = beta;
    }
    return _xifexpression;
  }
  
  public static class $generated__10_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__10(beta, alpha, indic);
    }
    
    public String toString() {
      return "if (indic == 0) alpha else beta";
    }
    
    private final RealVar beta;
    
    private final RealVar alpha;
    
    private final IntVar indic;
    
    public $generated__10_class(final RealVar beta, final RealVar alpha, final IntVar indic) {
      this.beta = beta;
      this.alpha = alpha;
      this.indic = indic;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentInt
   */
  private static IntVar $generated__11() {
    IntScalar _latentInt = StaticUtils.latentInt();
    return _latentInt;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__12(final IntVar indic) {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentRealList(2)
   */
  private static List<RealVar> $generated__13(final IntVar indic, final RealVar alpha) {
    List<RealVar> _latentRealList = StaticUtils.latentRealList(2);
    return _latentRealList;
  }
  
  /**
   * Auxiliary method generated to translate:
   * fixedIntList(12, 32)
   */
  private static List<IntVar> $generated__14(final IntVar indic, final RealVar alpha, final List<RealVar> betas) {
    List<IntVar> _fixedIntList = StaticUtils.fixedIntList(12, 32);
    return _fixedIntList;
  }
  
  /**
   * Note: the generated code has the following properties used at runtime:
   *   - all arguments are annotated with a BlangVariable annotation
   *   - params additionally have a Param annotation
   *   - the order of the arguments is as follows:
   *     - first, all the random variables in the order they occur in the blang file
   *     - second, all the params in the order they occur in the blang file
   * 
   */
  public Both(@DeboxedName("indic") final IntVar indic, @DeboxedName("alpha") final RealVar alpha, @DeboxedName("betas") final List<RealVar> betas, @DeboxedName("xs") final List<IntVar> xs) {
    this.indic = indic;
    this.alpha = alpha;
    this.betas = betas;
    this.xs = xs;
  }
  
  /**
   * A component can be either a distribution, support constraint, or another model  
   * which recursively defines additional components.
   */
  public Collection<ModelComponent> components() {
    ArrayList<ModelComponent> components = new ArrayList();
    
    { // Code generated by: indic ~ Bernoulli(0.5)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Bernoulli(
          $generated__0(indic, alpha, betas, xs), 
          new $generated__1_class()
        )
        );
    }
    { // Code generated by: alpha ~ Exponential(0.1)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Exponential(
          $generated__2(indic, alpha, betas, xs), 
          new $generated__3_class()
        )
        );
    }
    for (int i : $generated__4(indic, alpha, betas, xs)) {
      { // Code generated by: betas.get(i) ~ Exponential(0.1)
        // Construction and addition of the factor/model:
        components.add(
          new blang.distributions.Exponential(
            $generated__5(i, indic, alpha, betas, xs), 
            new $generated__6_class()
          )
          );
      }
    }
    for (int i : $generated__7(indic, alpha, betas, xs)) {
      { // Code generated by: xs.get(i) | RealVar beta = betas.get(i), alpha, indic ~ Poisson(if (indic == 0) alpha else beta)
        // Required initialization:
        RealVar beta = $generated__8(i, indic, alpha, betas, xs);
        // Construction and addition of the factor/model:
        components.add(
          new blang.distributions.Poisson(
            $generated__9(i, indic, alpha, betas, xs), 
            new $generated__10_class(beta, alpha, indic)
          )
          );
      }
    }
    
    return components;
  }
}
