package ex.hole;

import blang.core.DeboxedName;
import blang.core.IntVar;
import blang.core.Model;
import blang.core.ModelBuilder;
import blang.core.ModelComponent;
import blang.core.RealVar;
import blang.inits.Arg;
import blang.inits.DesignatedConstructor;
import blang.types.StaticUtils;
import blang.types.internals.RealScalar;
import ca.ubc.stat.blang.StaticJavaUtils;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Optional;
import java.util.function.Supplier;

@SuppressWarnings("all")
public class First implements Model {
  public static class Builder implements ModelBuilder {
    private boolean fromCommandLine = false;
    
    @Arg
    public Optional<List<IntVar>> xs;
    
    public First.Builder setXs(final List<IntVar> xs) {
      // work around typeRef(..) limitation
      Optional<List<IntVar>> $generated__dummy = null;
      this.xs = Optional.of(xs);
      return this;
    }
    
    @Arg
    public Optional<RealVar> alpha;
    
    public First.Builder setAlpha(final RealVar alpha) {
      // work around typeRef(..) limitation
      Optional<RealVar> $generated__dummy = null;
      this.alpha = Optional.of(alpha);
      return this;
    }
    
    public First build() {
      // For each optional type, either get the value, or evaluate the ?: expression
      List<IntVar> xs;
      if (this.xs != null && this.xs.isPresent()) {
        xs = this.xs.get();
      } else {
        xs = $generated__5();
      }
      final List<IntVar> __xs = xs;
      RealVar alpha;
      if (this.alpha != null && this.alpha.isPresent()) {
        alpha = this.alpha.get();
      } else {
        alpha = $generated__6(xs);
      }
      final RealVar __alpha = alpha;
      // Build the instance after boxing params
      return new First(
        __xs, 
        __alpha
      );
    }
  }
  
  @DesignatedConstructor
  public static First.Builder builderFromCommandLine() {
    Builder result = new Builder();
    result.fromCommandLine = true;
    return result;
  }
  
  private final List<IntVar> xs;
  
  public List<IntVar> getXs() {
    return xs;
  }
  
  private final RealVar alpha;
  
  public RealVar getAlpha() {
    return alpha;
  }
  
  /**
   * Utility main method for posterior inference on this model
   */
  public static void main(final String[] arguments) {
    StaticJavaUtils.callRunner(Builder.class, arguments);
  }
  
  /**
   * Auxiliary method generated to translate:
   * alpha
   */
  private static RealVar $generated__0(final List<IntVar> xs, final RealVar alpha) {
    return alpha;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0.1
   */
  private static RealVar $generated__1() {
    return new blang.core.RealConstant(0.1);
  }
  
  public static class $generated__1_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__1();
    }
    
    public String toString() {
      return "0.1";
    }
    
    public $generated__1_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * xs
   */
  private static Iterable<IntVar> $generated__2(final List<IntVar> xs, final RealVar alpha) {
    return xs;
  }
  
  /**
   * Auxiliary method generated to translate:
   * x
   */
  private static IntVar $generated__3(final IntVar x, final List<IntVar> xs, final RealVar alpha) {
    return x;
  }
  
  /**
   * Auxiliary method generated to translate:
   * alpha
   */
  private static RealVar $generated__4(final RealVar alpha) {
    return alpha;
  }
  
  public static class $generated__4_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__4(alpha);
    }
    
    public String toString() {
      return "alpha";
    }
    
    private final RealVar alpha;
    
    public $generated__4_class(final RealVar alpha) {
      this.alpha = alpha;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * fixedIntList(12, 32)
   */
  private static List<IntVar> $generated__5() {
    List<IntVar> _fixedIntList = StaticUtils.fixedIntList(12, 32);
    return _fixedIntList;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentReal
   */
  private static RealVar $generated__6(final List<IntVar> xs) {
    RealScalar _latentReal = StaticUtils.latentReal();
    return _latentReal;
  }
  
  /**
   * Note: the generated code has the following properties used at runtime:
   *   - all arguments are annotated with a BlangVariable annotation
   *   - params additionally have a Param annotation
   *   - the order of the arguments is as follows:
   *     - first, all the random variables in the order they occur in the blang file
   *     - second, all the params in the order they occur in the blang file
   * 
   */
  public First(@DeboxedName("xs") final List<IntVar> xs, @DeboxedName("alpha") final RealVar alpha) {
    this.xs = xs;
    this.alpha = alpha;
  }
  
  /**
   * A component can be either a distribution, support constraint, or another model  
   * which recursively defines additional components.
   */
  public Collection<ModelComponent> components() {
    ArrayList<ModelComponent> components = new ArrayList();
    
    { // Code generated by: alpha ~ Exponential(0.1)
      // Construction and addition of the factor/model:
      components.add(
        new blang.distributions.Exponential(
          $generated__0(xs, alpha), 
          new $generated__1_class()
        )
        );
    }
    for (IntVar x : $generated__2(xs, alpha)) {
      { // Code generated by: x | alpha ~ Poisson(alpha)
        // Construction and addition of the factor/model:
        components.add(
          new blang.distributions.Poisson(
            $generated__3(x, xs, alpha), 
            new $generated__4_class(alpha)
          )
          );
      }
    }
    
    return components;
  }
}
