package ex.hole;

import blang.core.DeboxedName;
import blang.core.IntVar;
import blang.core.Model;
import blang.core.ModelBuilder;
import blang.core.ModelComponent;
import blang.core.RealVar;
import blang.inits.Arg;
import blang.inits.DesignatedConstructor;
import blang.types.StaticUtils;
import ca.ubc.stat.blang.StaticJavaUtils;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Optional;
import java.util.function.Supplier;
import org.eclipse.xtext.xbase.lib.IntegerRange;

@SuppressWarnings("all")
public class Second implements Model {
  public static class Builder implements ModelBuilder {
    private boolean fromCommandLine = false;
    
    @Arg
    public Optional<List<IntVar>> xs;
    
    public Second.Builder setXs(final List<IntVar> xs) {
      // work around typeRef(..) limitation
      Optional<List<IntVar>> $generated__dummy = null;
      this.xs = Optional.of(xs);
      return this;
    }
    
    @Arg
    public Optional<List<RealVar>> betas;
    
    public Second.Builder setBetas(final List<RealVar> betas) {
      // work around typeRef(..) limitation
      Optional<List<RealVar>> $generated__dummy = null;
      this.betas = Optional.of(betas);
      return this;
    }
    
    public Second build() {
      // For each optional type, either get the value, or evaluate the ?: expression
      List<IntVar> xs;
      if (this.xs != null && this.xs.isPresent()) {
        xs = this.xs.get();
      } else {
        xs = $generated__6();
      }
      final List<IntVar> __xs = xs;
      List<RealVar> betas;
      if (this.betas != null && this.betas.isPresent()) {
        betas = this.betas.get();
      } else {
        betas = $generated__7(xs);
      }
      final List<RealVar> __betas = betas;
      // Build the instance after boxing params
      return new Second(
        __xs, 
        __betas
      );
    }
  }
  
  @DesignatedConstructor
  public static Second.Builder builderFromCommandLine() {
    Builder result = new Builder();
    result.fromCommandLine = true;
    return result;
  }
  
  private final List<IntVar> xs;
  
  public List<IntVar> getXs() {
    return xs;
  }
  
  private final List<RealVar> betas;
  
  public List<RealVar> getBetas() {
    return betas;
  }
  
  /**
   * Utility main method for posterior inference on this model
   */
  public static void main(final String[] arguments) {
    StaticJavaUtils.callRunner(Builder.class, arguments);
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0..1
   */
  private static Iterable<Integer> $generated__0(final List<IntVar> xs, final List<RealVar> betas) {
    IntegerRange _upTo = new IntegerRange(0, 1);
    return _upTo;
  }
  
  /**
   * Auxiliary method generated to translate:
   * betas.get(i)
   */
  private static RealVar $generated__1(final int i, final List<IntVar> xs, final List<RealVar> betas) {
    RealVar _get = betas.get(i);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * 0.1
   */
  private static RealVar $generated__2() {
    return new blang.core.RealConstant(0.1);
  }
  
  public static class $generated__2_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__2();
    }
    
    public String toString() {
      return "0.1";
    }
    
    public $generated__2_class() {
      
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * betas.get(i)
   */
  private static RealVar $generated__3(final int i, final List<IntVar> xs, final List<RealVar> betas) {
    RealVar _get = betas.get(i);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * xs.get(i)
   */
  private static IntVar $generated__4(final int i, final List<IntVar> xs, final List<RealVar> betas) {
    IntVar _get = xs.get(i);
    return _get;
  }
  
  /**
   * Auxiliary method generated to translate:
   * beta
   */
  private static RealVar $generated__5(final RealVar beta) {
    return beta;
  }
  
  public static class $generated__5_class implements Supplier<RealVar> {
    public RealVar get() {
      return $generated__5(beta);
    }
    
    public String toString() {
      return "beta";
    }
    
    private final RealVar beta;
    
    public $generated__5_class(final RealVar beta) {
      this.beta = beta;
    }
  }
  
  /**
   * Auxiliary method generated to translate:
   * fixedIntList(12, 32)
   */
  private static List<IntVar> $generated__6() {
    List<IntVar> _fixedIntList = StaticUtils.fixedIntList(12, 32);
    return _fixedIntList;
  }
  
  /**
   * Auxiliary method generated to translate:
   * latentRealList(2)
   */
  private static List<RealVar> $generated__7(final List<IntVar> xs) {
    List<RealVar> _latentRealList = StaticUtils.latentRealList(2);
    return _latentRealList;
  }
  
  /**
   * Note: the generated code has the following properties used at runtime:
   *   - all arguments are annotated with a BlangVariable annotation
   *   - params additionally have a Param annotation
   *   - the order of the arguments is as follows:
   *     - first, all the random variables in the order they occur in the blang file
   *     - second, all the params in the order they occur in the blang file
   * 
   */
  public Second(@DeboxedName("xs") final List<IntVar> xs, @DeboxedName("betas") final List<RealVar> betas) {
    this.xs = xs;
    this.betas = betas;
  }
  
  /**
   * A component can be either a distribution, support constraint, or another model  
   * which recursively defines additional components.
   */
  public Collection<ModelComponent> components() {
    ArrayList<ModelComponent> components = new ArrayList();
    
    for (int i : $generated__0(xs, betas)) {
      { // Code generated by: betas.get(i) ~ Exponential(0.1)
        // Construction and addition of the factor/model:
        components.add(
          new blang.distributions.Exponential(
            $generated__1(i, xs, betas), 
            new $generated__2_class()
          )
          );
      }
      { // Code generated by: xs.get(i) | RealVar beta = betas.get(i) ~ Poisson(beta)
        // Required initialization:
        RealVar beta = $generated__3(i, xs, betas);
        // Construction and addition of the factor/model:
        components.add(
          new blang.distributions.Poisson(
            $generated__4(i, xs, betas), 
            new $generated__5_class(beta)
          )
          );
      }
    }
    
    return components;
  }
}
