require("ggplot2")
require("dplyr")

data <- read.csv("/Users/bouchard/w/blogobayes/www/ex/hole/results/all/Second--1636439421/samples/betas.csv")

# ggplot has bad default sizes for large facetting
verticalSize <- 2.0 *  length(unique(data$index_0)) 
horizontalSize <- 4.0


p <- ggplot(data, aes(x = sample, y = value)) +
  geom_point(size = 0.1) + geom_line(alpha = 0.5) + facet_grid(index_0 ~ .
  , scales="free") + 
  theme_bw() + 
  xlab("MCMC iteration") +
  ylab("sample") +
  ggtitle("Trace plot for: betas")
ggsave("/Users/bouchard/w/blogobayes/www/ex/hole/results/all/Second--1636439421/tracePlotsFull/betas.pdf", limitsize = F, height = verticalSize, width = horizontalSize)
